//+-------------------------------------------------------------------+
//|                                            Bollinger Bands %b.mq4 |
//|                           Original indicator by Alejandro Galindo |
//|                  Modified and Corrected by Linuxser for forex TSD |
//|                                                                   |
//| John Bollinger original formula is:                               |
//| (Last - Lower BB)/(Upper BB - Lower BB)                           |
//+-------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Gold


//---- input parameters
extern int BBPeriod          = 20;
extern int StdDeviation      =  2;
extern int SmoothingMAPeriod =  5;
extern int SmoothingMAMethod = MODE_EMA;
//---- buffers
double BLGBuffer[];
double Buffer3[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- indicator line
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,BLGBuffer);
   SetIndexBuffer(1,Buffer3);
   SetLevelValue(0,0);
   SetLevelValue(1,50);
   SetLevelValue(2,100);
   SetLevelStyle(STYLE_SOLID,1,DimGray);
//---- name for DataWindow and indicator subwindow label
   short_name="Bollinger Percent B (%b)("+BBPeriod+","+StdDeviation+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//----
   SetIndexDrawBegin(0,BBPeriod);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Momentum                                                         |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars - counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(i = limit; i >= 0 ; i--)
   {
      double bbUp = iBands(NULL,0,BBPeriod,StdDeviation,0,PRICE_CLOSE,MODE_UPPER,i);
      double bbLo = iBands(NULL,0,BBPeriod,StdDeviation,0,PRICE_CLOSE,MODE_LOWER,i);
      if (bbUp!=bbLo)
            BLGBuffer[i]= 100.0*(Close[i] - bbLo)/(bbUp-bbLo);
      else  BLGBuffer[i]= 0;
   }
   for(i = limit; i >= 0 ; i--) Buffer3[i] = iMAOnArray(BLGBuffer, 0, SmoothingMAPeriod, 0, SmoothingMAMethod, i);  
   return(0);
  }
//+------------------------------------------------------------------+